// Code generated by thor;
// thor

package groupstore

import (
	"context"
	"demo/internal/model/entity"
	"demo/internal/repository/group"

	"github.com/jinzhu/gorm"
)

// groupRepoImpl ...
type groupRepoImpl struct {
	*gorm.DB
}

// GetActiveByID ...
func (o *groupRepoImpl) GetActiveByID(ctx context.Context, id string) (*entity.Group, error) {
	return o.getActiveByID(ctx, id)
}

// ListActive ...
func (o *groupRepoImpl) ListActive(ctx context.Context, limit int64, offset int64) ([]*entity.Group, error) {
	return o.listActive(ctx, limit, offset)
}

// Remove ...
func (o *groupRepoImpl) Remove(ctx context.Context, id string) error {
	return o.remove(ctx, id)
}

// Save ...
func (o *groupRepoImpl) Save(ctx context.Context, obj *entity.Group) error {
	return o.save(ctx, obj)
}

// SetDefault ...
func (o *groupRepoImpl) SetDefault(ctx context.Context, id string, isDefault bool) (*entity.Group, error) {
	return o.setDefault(ctx, id, isDefault)
}

// UpdateMap ...
func (o *groupRepoImpl) UpdateMap(ctx context.Context, id string, obj map[string]interface{}) (*entity.Group, error) {
	return o.updateMap(ctx, id, obj)
}

// NewGroupRepoImpl creates a new instance of groupRepoImpl, contains whole common functions
// for a service
func NewGroupRepoImpl(db *gorm.DB) group.IRepository {
	return &groupRepoImpl{
		DB: db,
	}
}
